.686
.model flat, stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\masm32.inc
include \masm32\include\user32.inc
include \masm32\include\msvcrt.inc
include \masm32\macros\macros.asm

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\msvcrt.lib
include TIMERS.ASM

  zero_it 		proto   :DWORD,:DWORD
  xzero_it 		proto   :DWORD,:DWORD
  ZeroMemD 		proto   :DWORD,:DWORD
  fZeroMemory 	proto   :DWORD,:DWORD
  xzero_it2 	proto   :DWORD,:DWORD
  AzmtMemZero   proto   :DWORD,:DWORD
  _memfill      proto   :DWORD,:DWORD,:DWORD
  jdoe_memfill  proto   :DWORD,:DWORD,:DWORD

  .data?
    szBuff db 65536 dup(?)

  .data
    align 4
    numz dd 16,64,256,1024,2048
    cntr dd 5

.code
  start:
    push esi
    mov esi, OFFSET numz

  begin:

    print "; ------------- Sample size = "
    print str$([esi])," bytes ---------------------",13,10,13,10

    LOOP_COUNT EQU 1000000
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke  zero_it,addr szBuff,[esi]
    counter_end
    push eax
    print chr$("zero_it - hutch: ")
    pop eax
    print str$(eax)
    print chr$(13,10)

    LOOP_COUNT EQU 1000000
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke  xzero_it,addr szBuff,[esi]
    counter_end
    push eax
    print chr$("xzero_it - The Dude of Dudes: ")
    pop eax
    print str$(eax)
    print chr$(13,10)

    LOOP_COUNT EQU 1000000
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke  xzero_it2,addr szBuff,[esi]
    counter_end
    push eax
    print chr$("xzero_it2 - pro3carp3: ")
    pop eax
    print str$(eax)
    print chr$(13,10)

    LOOP_COUNT EQU 1000000
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke RtlZeroMemory,addr szBuff,[esi]
    counter_end
    push eax
    print chr$("RtlZeroMemory - Microsoft: ")
    pop eax
    print str$(eax)
    print chr$(13,10)

    LOOP_COUNT EQU 1000000
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke ZeroMemD,addr szBuff,[esi]
    counter_end
    push eax
    print chr$("ZeroMemD - unknown: ")
    pop eax
    print str$(eax)
    print chr$(13,10)

    LOOP_COUNT EQU 1000000
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke fZeroMemory,addr szBuff,[esi]
    counter_end
    push eax
    print chr$("fZeroMemory- Four-F: ")
    pop eax
    print str$(eax)
    print chr$(13,10)
    
    LOOP_COUNT EQU 1000000
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	invoke AzmtMemZero,addr szBuff,[esi]
	counter_end
	push eax
	print chr$("AzmtMemZero - jdoe ")
	pop eax
	print str$(eax)
	print chr$(13,10)
	
	LOOP_COUNT EQU 1000000
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	invoke RtlFillMemory,addr szBuff,[esi],0
	counter_end
	push eax
	print chr$("RtlFillMemory - Microsoft(NT+ only)")
	pop eax
	print str$(eax)
	print chr$(13,10)
	
	LOOP_COUNT EQU 1000000
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
       ;invoke crt_memset, addr szBuff, 0, [esi] 
       push [esi]
       push 0
       push offset szBuff
       call crt_memset
       add esp,12	
	counter_end
	push eax
	print chr$("msvcrt memset - Microsoft: ")
	pop eax
	print str$(eax)
	print chr$(13,10)
	;!

    LOOP_COUNT EQU 1000000
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke _memfill,addr szBuff,[esi],0
    counter_end
    push eax
    print chr$("_memfill - modified memfill & rep stosd : ")
    pop eax
    print str$(eax)
    print chr$(13,10)

    LOOP_COUNT EQU 1000000
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke memfill,addr szBuff,[esi],0
    counter_end
    push eax
    print chr$("memfill - masm32 lib: ")
    pop eax
    print str$(eax)
    print chr$(13,10)

    LOOP_COUNT EQU 1000000
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke jdoe_memfill,addr szBuff,[esi],0
    counter_end
    push eax
    print chr$("jdoe_memfill - modified memfill by jdoe : ")
    pop eax
    print str$(eax)
    print chr$(13,10,13,10)

    add esi, 4
    sub cntr, 1
    jnz begin

    inkey

    pop esi

invoke ExitProcess,0

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 4
;by hutch
zero_it proc lpmem:DWORD,cnt:DWORD

    mov ecx, [esp+4]        ; address in ECX
    mov edx, [esp+8]        ; Count in EDX
    xor eax, eax            ; set EAX to zero to zero AL

  @@:
    mov [ecx+edx], al       ; zero byte at address in ECX
    sub edx, 1              ; decrement EDX
    jns @B                  ; loop back if > -1

    ret 8

zero_it endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

   
;by The Dude of Dudes                  
xzero_it proc lpmem:DWORD,cnt:DWORD

    push edi

mov edi, lpmem
mov ecx, cnt     
shr ecx, 2       ;<----- div by 4 (sizeof dword)
;inc ecx           <------ not necessary
cld
xor eax, eax   ; set EAX to zero
rep stosd       ;<------- instead of stosb, stores a dword every iteration and adds 4 to edi

    pop edi

ret

xzero_it endp

;pro3carp3
xzero_it2 proc lpmem:DWORD, cnt:DWORD

    push edi

cld
xor eax, eax
mov edi, lpmem
mov ecx, cnt
mov edx, ecx   
shr ecx, 2d
rep stosd
mov ecx, edx
and ecx, 3d    ; <-- correction
rep stosb

    pop edi

ret

xzero_it2 endp

;by ?
ZeroMemD proc dest:DWORD,lenx:DWORD

; taking into account xor eax, eax
; ProcSize = 48 bytes

push edi
        mov  edi, dest								; <---- !!! moved by me (Four-F) otherwise crash if len<4
        cld											; <---- added by me (Four-F)
        cmp  lenx, 4        ; if < DWORD size
        jl  @@@1           ; copy as BYTE
        

        mov  ecx, lenx

        push ecx           ; copy ecx
        shr  ecx, 2        ; integer divide by 4
        shl  ecx, 2        ; multiply by 4 for dividend
        pop  edx
        sub  edx, ecx      ; remainder in edx
        shr  ecx, 2           ; div by 4 for DWORD

        rep  stosd         ; copy as DWORD
        mov  ecx, edx      ; put remainder in counter
        jmp  @@@2

      @@@1:
        mov  ecx, lenx
      @@@2:
        rep  stosb         ; copy as BYTE
pop edi
        ret

ZeroMemD endp

;by Four-F
fZeroMemory proc pDest:LPVOID, cbLen:UINT

; (c) Four-F, 2002
; four-f@mail.ru

; Assume pDest is valid

; ProcSize = 32 bytes

option PROLOGUE:NONE
option EPILOGUE:NONE

	xor eax, eax
	push edi
	mov ecx, [esp + sizeof DWORD * 3]
	mov edx, ecx
	cld
	mov edi, [esp + sizeof DWORD * 2]
	shr ecx, 2
	jz @F
	rep stosd
@@:
	and edx, 011y
	mov ecx, edx
	rep stosb
	pop edi

	ret (sizeof DWORD)*2

option PROLOGUE:PROLOGUEDEF
option EPILOGUE:EPILOGUEDEF

fZeroMemory endp


OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16
 
NOP
NOP
NOP
;by jdoe
AzmtMemZero PROC p_lpDest:DWORD, p_dwLen:DWORD

   mov edx, dword ptr [esp+4]
   mov dword ptr [esp+4], edi
   mov eax, dword ptr [esp+8]

   xor edi, edi

@32:
   mov ecx, eax
   shr ecx, 5
   jz @16
@@:
   add edi, 32
   mov dword ptr [edx+edi-32], 0
   mov dword ptr [edx+edi-28], 0
   mov dword ptr [edx+edi-24], 0
   mov dword ptr [edx+edi-20], 0
   mov dword ptr [edx+edi-16], 0
   mov dword ptr [edx+edi-12], 0
   mov dword ptr [edx+edi-8], 0
   mov dword ptr [edx+edi-4], 0
   sub ecx, 1
   jnz @B

@16:
   mov ecx, eax
   sub ecx, edi
   shr ecx, 4
   jz @08
   add edi, 16
   mov dword ptr [edx+edi-16], 0
   mov dword ptr [edx+edi-12], 0
   mov dword ptr [edx+edi-8], 0
   mov dword ptr [edx+edi-4], 0

@08:
   mov ecx, eax
   sub ecx, edi
   shr ecx, 3
   jz @04
   add edi, 8
   mov dword ptr [edx+edi-8], 0
   mov dword ptr [edx+edi-4], 0

@04:
   mov ecx, eax
   sub ecx, edi
   shr ecx, 2
   jz @01
   add edi, 4
   mov dword ptr [edx+edi-4], 0

@01:
   sub eax, edi
   jz Exit
@@:
   mov byte ptr [edx+edi], 0
   add edi, 1
   sub eax, 1
   jnz @B

Exit:

   mov edi, dword ptr [esp+4]
   ret 8

AzmtMemZero ENDP

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4
_memfill proc lpmem:DWORD,ln:DWORD,fill:DWORD

    push edi
    mov edi, [esp+8]    ; lpmem
    mov ecx, [esp+12]   ; byte length
    mov eax, [esp+16]   ; fill

    cmp ecx, 512
    mov edx, ecx
    jnb repstosd

    shr ecx, 5          ; divide by 32
    cmp ecx, 0
    jz rmndr

    align 4

  ; ------------
  ; unroll by 8
  ; ------------
  @@:

    mov [edi],    eax   ; put fill chars at address in edi
    mov [edi+4],  eax
    mov [edi+8],  eax
    mov [edi+12], eax
    mov [edi+16], eax
    mov [edi+20], eax
    mov [edi+24], eax
    mov [edi+28], eax
    add edi, 32
    dec ecx
    jnz @B

  rmndr:

    and edx, 31         ; get remainder
    mov ecx, edx
    jz  mfQuit
    shr ecx, 2          ; divide by 4

  @@:

    mov [edi], eax
    add edx, 4
    dec ecx
    jnz @B
    jmp mfQuit

  repstosd:

    shr ecx, 2
    rep stosd           ; divide by 4

  mfQuit:

    pop edi
    ret 12

_memfill endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

jdoe_memfill proc lpmem:DWORD,ln:DWORD,fill:DWORD

    mov edx, [esp+4]           ; buffer address
    mov eax, [esp+12]          ; fill chars

    mov ecx, [esp+8]           ; byte length
    sub edx, eax
    shr ecx, 5                 ; divide by 32
    jz rmndr

    align 4

  ; ------------
  ; unroll by 8
  ; ------------
  @@:
    mov [edx+eax+28], eax
    mov [edx+eax+24], eax
    mov [edx+eax+20], eax
    mov [edx+eax+16], eax
    mov [edx+eax+12], eax
    mov [edx+eax+8],  eax
    mov [edx+eax+4],  eax      ; put fill chars at address in edx
    mov [edx+eax],    eax
    add edx, 32
    sub ecx, 1
    jnz @B

  rmndr:

    and dword ptr [esp+8], 31  ; get remainder
    jz mfQuit
    mov ecx, [esp+8]
    shr ecx, 2                 ; divide by 4

  @@:
    mov [edx+eax], eax
    add edx, 4
    sub ecx, 1
    jnz @B

  mfQuit:

    ret 12

jdoe_memfill endp

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

; 

end start
